/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import * as cdktf from 'cdktf';
import { OneDashboardPageWidgetStackedBarColors, OneDashboardPageWidgetStackedBarColorsList, OneDashboardPageWidgetStackedBarNrqlQuery, OneDashboardPageWidgetStackedBarNrqlQueryList, OneDashboardPageWidgetStackedBarNullValues, OneDashboardPageWidgetStackedBarNullValuesList, OneDashboardPageWidgetArea, OneDashboardPageWidgetAreaList, OneDashboardPageWidgetBar, OneDashboardPageWidgetBarList, OneDashboardPageWidgetBillboard, OneDashboardPageWidgetBillboardList, OneDashboardPageWidgetBullet, OneDashboardPageWidgetBulletList, OneDashboardPageWidgetFunnel, OneDashboardPageWidgetFunnelList, OneDashboardPageWidgetHeatmap, OneDashboardPageWidgetHeatmapList, OneDashboardPageWidgetHistogram, OneDashboardPageWidgetHistogramList, OneDashboardPageWidgetJson, OneDashboardPageWidgetJsonList, OneDashboardPageWidgetLine, OneDashboardPageWidgetLineList, OneDashboardPageWidgetLogTable, OneDashboardPageWidgetLogTableList, OneDashboardPageWidgetMarkdown, OneDashboardPageWidgetMarkdownList, OneDashboardPageWidgetPie, OneDashboardPageWidgetPieList } from './structs0';
export interface OneDashboardPageWidgetStackedBarUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetStackedBarUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetStackedBarUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetStackedBarUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarUnitsToTerraform(struct?: OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBarUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetStackedBarUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarUnitsOutputReference;
}
export interface OneDashboardPageWidgetStackedBar {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetStackedBarColors[] | cdktf.IResolvable;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery: OneDashboardPageWidgetStackedBarNrqlQuery[] | cdktf.IResolvable;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetStackedBarNullValues[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetStackedBarToTerraform(struct?: OneDashboardPageWidgetStackedBar | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetStackedBarOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetStackedBar | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetStackedBar | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetStackedBarColorsList;
    putColors(value: OneDashboardPageWidgetStackedBarColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarColors[] | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardPageWidgetStackedBarNrqlQueryList;
    putNrqlQuery(value: OneDashboardPageWidgetStackedBarNrqlQuery[] | cdktf.IResolvable): void;
    get nrqlQueryInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarNrqlQuery[] | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetStackedBarNullValuesList;
    putNullValues(value: OneDashboardPageWidgetStackedBarNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarNullValues[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetStackedBarUnitsList;
    putUnits(value: OneDashboardPageWidgetStackedBarUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBarUnits[] | undefined;
}
export declare class OneDashboardPageWidgetStackedBarList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetStackedBarOutputReference;
}
export interface OneDashboardPageWidgetTableColorsSeriesOverrides {
    /**
    * Color code
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetTableColorsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableColorsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableColorsSeriesOverrides | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableColorsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableColorsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableColors {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#color OneDashboard#color}
    */
    readonly color?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableColorsToTerraform(struct?: OneDashboardPageWidgetTableColors | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableColorsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableColors | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableColors | cdktf.IResolvable | undefined);
    private _color?;
    get color(): string;
    set color(value: string);
    resetColor(): void;
    get colorInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableColorsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableColorsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableColorsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableColorsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableColorsOutputReference;
}
export interface OneDashboardPageWidgetTableNrqlQuery {
    /**
    * The account id used for the NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#account_id OneDashboard#account_id}
    */
    readonly accountId?: number;
    /**
    * The NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardPageWidgetTableNrqlQueryToTerraform(struct?: OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNrqlQuery | cdktf.IResolvable | undefined);
    private _accountId?;
    get accountId(): number;
    set accountId(value: number);
    resetAccountId(): void;
    get accountIdInput(): number | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableNrqlQueryList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNrqlQueryOutputReference;
}
export interface OneDashboardPageWidgetTableNullValuesSeriesOverrides {
    /**
    * Null value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
}
export declare function oneDashboardPageWidgetTableNullValuesSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNullValuesSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNullValuesSeriesOverrides | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableNullValuesSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNullValuesSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableNullValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#null_value OneDashboard#null_value}
    */
    readonly nullValue?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableNullValuesToTerraform(struct?: OneDashboardPageWidgetTableNullValues | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableNullValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableNullValues | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableNullValues | cdktf.IResolvable | undefined);
    private _nullValue?;
    get nullValue(): string;
    set nullValue(value: string);
    resetNullValue(): void;
    get nullValueInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableNullValuesSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNullValuesSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableNullValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableNullValuesOutputReference;
}
export interface OneDashboardPageWidgetTableUnitsSeriesOverrides {
    /**
    * Series name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_name OneDashboard#series_name}
    */
    readonly seriesName?: string;
    /**
    * Unit name
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
}
export declare function oneDashboardPageWidgetTableUnitsSeriesOverridesToTerraform(struct?: OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableUnitsSeriesOverridesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableUnitsSeriesOverrides | cdktf.IResolvable | undefined);
    private _seriesName?;
    get seriesName(): string;
    set seriesName(value: string);
    resetSeriesName(): void;
    get seriesNameInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
}
export declare class OneDashboardPageWidgetTableUnitsSeriesOverridesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableUnitsSeriesOverridesOutputReference;
}
export interface OneDashboardPageWidgetTableUnits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#unit OneDashboard#unit}
    */
    readonly unit?: string;
    /**
    * series_overrides block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#series_overrides OneDashboard#series_overrides}
    */
    readonly seriesOverrides?: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableUnitsToTerraform(struct?: OneDashboardPageWidgetTableUnits | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableUnitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTableUnits | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTableUnits | cdktf.IResolvable | undefined);
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _seriesOverrides;
    get seriesOverrides(): OneDashboardPageWidgetTableUnitsSeriesOverridesList;
    putSeriesOverrides(value: OneDashboardPageWidgetTableUnitsSeriesOverrides[] | cdktf.IResolvable): void;
    resetSeriesOverrides(): void;
    get seriesOverridesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableUnitsSeriesOverrides[] | undefined;
}
export declare class OneDashboardPageWidgetTableUnitsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableUnitsOutputReference;
}
export interface OneDashboardPageWidgetTable {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#column OneDashboard#column}
    */
    readonly column: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#facet_show_other_series OneDashboard#facet_show_other_series}
    */
    readonly facetShowOtherSeries?: boolean | cdktf.IResolvable;
    /**
    * Use this item to filter the current dashboard
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#filter_current_dashboard OneDashboard#filter_current_dashboard}
    */
    readonly filterCurrentDashboard?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#height OneDashboard#height}
    */
    readonly height?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#ignore_time_range OneDashboard#ignore_time_range}
    */
    readonly ignoreTimeRange?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#legend_enabled OneDashboard#legend_enabled}
    */
    readonly legendEnabled?: boolean | cdktf.IResolvable;
    /**
    * Related entities. Currently only supports Dashboard entities, but may allow other cases in the future.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#linked_entity_guids OneDashboard#linked_entity_guids}
    */
    readonly linkedEntityGuids?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#row OneDashboard#row}
    */
    readonly row: number;
    /**
    * A title for the widget.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#width OneDashboard#width}
    */
    readonly width?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#y_axis_left_max OneDashboard#y_axis_left_max}
    */
    readonly yAxisLeftMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#y_axis_left_min OneDashboard#y_axis_left_min}
    */
    readonly yAxisLeftMin?: number;
    /**
    * colors block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#colors OneDashboard#colors}
    */
    readonly colors?: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable;
    /**
    * null_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#null_values OneDashboard#null_values}
    */
    readonly nullValues?: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable;
    /**
    * units block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#units OneDashboard#units}
    */
    readonly units?: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable;
}
export declare function oneDashboardPageWidgetTableToTerraform(struct?: OneDashboardPageWidgetTable | cdktf.IResolvable): any;
export declare class OneDashboardPageWidgetTableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPageWidgetTable | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPageWidgetTable | cdktf.IResolvable | undefined);
    private _column?;
    get column(): number;
    set column(value: number);
    get columnInput(): number | undefined;
    private _facetShowOtherSeries?;
    get facetShowOtherSeries(): boolean | cdktf.IResolvable;
    set facetShowOtherSeries(value: boolean | cdktf.IResolvable);
    resetFacetShowOtherSeries(): void;
    get facetShowOtherSeriesInput(): boolean | cdktf.IResolvable | undefined;
    private _filterCurrentDashboard?;
    get filterCurrentDashboard(): boolean | cdktf.IResolvable;
    set filterCurrentDashboard(value: boolean | cdktf.IResolvable);
    resetFilterCurrentDashboard(): void;
    get filterCurrentDashboardInput(): boolean | cdktf.IResolvable | undefined;
    private _height?;
    get height(): number;
    set height(value: number);
    resetHeight(): void;
    get heightInput(): number | undefined;
    get id(): string;
    private _ignoreTimeRange?;
    get ignoreTimeRange(): boolean | cdktf.IResolvable;
    set ignoreTimeRange(value: boolean | cdktf.IResolvable);
    resetIgnoreTimeRange(): void;
    get ignoreTimeRangeInput(): boolean | cdktf.IResolvable | undefined;
    private _legendEnabled?;
    get legendEnabled(): boolean | cdktf.IResolvable;
    set legendEnabled(value: boolean | cdktf.IResolvable);
    resetLegendEnabled(): void;
    get legendEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _linkedEntityGuids?;
    get linkedEntityGuids(): string[];
    set linkedEntityGuids(value: string[]);
    resetLinkedEntityGuids(): void;
    get linkedEntityGuidsInput(): string[] | undefined;
    private _row?;
    get row(): number;
    set row(value: number);
    get rowInput(): number | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _width?;
    get width(): number;
    set width(value: number);
    resetWidth(): void;
    get widthInput(): number | undefined;
    private _yAxisLeftMax?;
    get yAxisLeftMax(): number;
    set yAxisLeftMax(value: number);
    resetYAxisLeftMax(): void;
    get yAxisLeftMaxInput(): number | undefined;
    private _yAxisLeftMin?;
    get yAxisLeftMin(): number;
    set yAxisLeftMin(value: number);
    resetYAxisLeftMin(): void;
    get yAxisLeftMinInput(): number | undefined;
    private _colors;
    get colors(): OneDashboardPageWidgetTableColorsList;
    putColors(value: OneDashboardPageWidgetTableColors[] | cdktf.IResolvable): void;
    resetColors(): void;
    get colorsInput(): cdktf.IResolvable | OneDashboardPageWidgetTableColors[] | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardPageWidgetTableNrqlQueryList;
    putNrqlQuery(value: OneDashboardPageWidgetTableNrqlQuery[] | cdktf.IResolvable): void;
    get nrqlQueryInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNrqlQuery[] | undefined;
    private _nullValues;
    get nullValues(): OneDashboardPageWidgetTableNullValuesList;
    putNullValues(value: OneDashboardPageWidgetTableNullValues[] | cdktf.IResolvable): void;
    resetNullValues(): void;
    get nullValuesInput(): cdktf.IResolvable | OneDashboardPageWidgetTableNullValues[] | undefined;
    private _units;
    get units(): OneDashboardPageWidgetTableUnitsList;
    putUnits(value: OneDashboardPageWidgetTableUnits[] | cdktf.IResolvable): void;
    resetUnits(): void;
    get unitsInput(): cdktf.IResolvable | OneDashboardPageWidgetTableUnits[] | undefined;
}
export declare class OneDashboardPageWidgetTableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPageWidgetTable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageWidgetTableOutputReference;
}
export interface OneDashboardPage {
    /**
    * The dashboard page's description.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#description OneDashboard#description}
    */
    readonly description?: string;
    /**
    * The dashboard page's name.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * widget_area block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_area OneDashboard#widget_area}
    */
    readonly widgetArea?: OneDashboardPageWidgetArea[] | cdktf.IResolvable;
    /**
    * widget_bar block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_bar OneDashboard#widget_bar}
    */
    readonly widgetBar?: OneDashboardPageWidgetBar[] | cdktf.IResolvable;
    /**
    * widget_billboard block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_billboard OneDashboard#widget_billboard}
    */
    readonly widgetBillboard?: OneDashboardPageWidgetBillboard[] | cdktf.IResolvable;
    /**
    * widget_bullet block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_bullet OneDashboard#widget_bullet}
    */
    readonly widgetBullet?: OneDashboardPageWidgetBullet[] | cdktf.IResolvable;
    /**
    * widget_funnel block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_funnel OneDashboard#widget_funnel}
    */
    readonly widgetFunnel?: OneDashboardPageWidgetFunnel[] | cdktf.IResolvable;
    /**
    * widget_heatmap block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_heatmap OneDashboard#widget_heatmap}
    */
    readonly widgetHeatmap?: OneDashboardPageWidgetHeatmap[] | cdktf.IResolvable;
    /**
    * widget_histogram block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_histogram OneDashboard#widget_histogram}
    */
    readonly widgetHistogram?: OneDashboardPageWidgetHistogram[] | cdktf.IResolvable;
    /**
    * widget_json block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_json OneDashboard#widget_json}
    */
    readonly widgetJson?: OneDashboardPageWidgetJson[] | cdktf.IResolvable;
    /**
    * widget_line block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_line OneDashboard#widget_line}
    */
    readonly widgetLine?: OneDashboardPageWidgetLine[] | cdktf.IResolvable;
    /**
    * widget_log_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_log_table OneDashboard#widget_log_table}
    */
    readonly widgetLogTable?: OneDashboardPageWidgetLogTable[] | cdktf.IResolvable;
    /**
    * widget_markdown block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_markdown OneDashboard#widget_markdown}
    */
    readonly widgetMarkdown?: OneDashboardPageWidgetMarkdown[] | cdktf.IResolvable;
    /**
    * widget_pie block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_pie OneDashboard#widget_pie}
    */
    readonly widgetPie?: OneDashboardPageWidgetPie[] | cdktf.IResolvable;
    /**
    * widget_stacked_bar block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_stacked_bar OneDashboard#widget_stacked_bar}
    */
    readonly widgetStackedBar?: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable;
    /**
    * widget_table block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#widget_table OneDashboard#widget_table}
    */
    readonly widgetTable?: OneDashboardPageWidgetTable[] | cdktf.IResolvable;
}
export declare function oneDashboardPageToTerraform(struct?: OneDashboardPage | cdktf.IResolvable): any;
export declare class OneDashboardPageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardPage | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardPage | cdktf.IResolvable | undefined);
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    get guid(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _widgetArea;
    get widgetArea(): OneDashboardPageWidgetAreaList;
    putWidgetArea(value: OneDashboardPageWidgetArea[] | cdktf.IResolvable): void;
    resetWidgetArea(): void;
    get widgetAreaInput(): cdktf.IResolvable | OneDashboardPageWidgetArea[] | undefined;
    private _widgetBar;
    get widgetBar(): OneDashboardPageWidgetBarList;
    putWidgetBar(value: OneDashboardPageWidgetBar[] | cdktf.IResolvable): void;
    resetWidgetBar(): void;
    get widgetBarInput(): cdktf.IResolvable | OneDashboardPageWidgetBar[] | undefined;
    private _widgetBillboard;
    get widgetBillboard(): OneDashboardPageWidgetBillboardList;
    putWidgetBillboard(value: OneDashboardPageWidgetBillboard[] | cdktf.IResolvable): void;
    resetWidgetBillboard(): void;
    get widgetBillboardInput(): cdktf.IResolvable | OneDashboardPageWidgetBillboard[] | undefined;
    private _widgetBullet;
    get widgetBullet(): OneDashboardPageWidgetBulletList;
    putWidgetBullet(value: OneDashboardPageWidgetBullet[] | cdktf.IResolvable): void;
    resetWidgetBullet(): void;
    get widgetBulletInput(): cdktf.IResolvable | OneDashboardPageWidgetBullet[] | undefined;
    private _widgetFunnel;
    get widgetFunnel(): OneDashboardPageWidgetFunnelList;
    putWidgetFunnel(value: OneDashboardPageWidgetFunnel[] | cdktf.IResolvable): void;
    resetWidgetFunnel(): void;
    get widgetFunnelInput(): cdktf.IResolvable | OneDashboardPageWidgetFunnel[] | undefined;
    private _widgetHeatmap;
    get widgetHeatmap(): OneDashboardPageWidgetHeatmapList;
    putWidgetHeatmap(value: OneDashboardPageWidgetHeatmap[] | cdktf.IResolvable): void;
    resetWidgetHeatmap(): void;
    get widgetHeatmapInput(): cdktf.IResolvable | OneDashboardPageWidgetHeatmap[] | undefined;
    private _widgetHistogram;
    get widgetHistogram(): OneDashboardPageWidgetHistogramList;
    putWidgetHistogram(value: OneDashboardPageWidgetHistogram[] | cdktf.IResolvable): void;
    resetWidgetHistogram(): void;
    get widgetHistogramInput(): cdktf.IResolvable | OneDashboardPageWidgetHistogram[] | undefined;
    private _widgetJson;
    get widgetJson(): OneDashboardPageWidgetJsonList;
    putWidgetJson(value: OneDashboardPageWidgetJson[] | cdktf.IResolvable): void;
    resetWidgetJson(): void;
    get widgetJsonInput(): cdktf.IResolvable | OneDashboardPageWidgetJson[] | undefined;
    private _widgetLine;
    get widgetLine(): OneDashboardPageWidgetLineList;
    putWidgetLine(value: OneDashboardPageWidgetLine[] | cdktf.IResolvable): void;
    resetWidgetLine(): void;
    get widgetLineInput(): cdktf.IResolvable | OneDashboardPageWidgetLine[] | undefined;
    private _widgetLogTable;
    get widgetLogTable(): OneDashboardPageWidgetLogTableList;
    putWidgetLogTable(value: OneDashboardPageWidgetLogTable[] | cdktf.IResolvable): void;
    resetWidgetLogTable(): void;
    get widgetLogTableInput(): cdktf.IResolvable | OneDashboardPageWidgetLogTable[] | undefined;
    private _widgetMarkdown;
    get widgetMarkdown(): OneDashboardPageWidgetMarkdownList;
    putWidgetMarkdown(value: OneDashboardPageWidgetMarkdown[] | cdktf.IResolvable): void;
    resetWidgetMarkdown(): void;
    get widgetMarkdownInput(): cdktf.IResolvable | OneDashboardPageWidgetMarkdown[] | undefined;
    private _widgetPie;
    get widgetPie(): OneDashboardPageWidgetPieList;
    putWidgetPie(value: OneDashboardPageWidgetPie[] | cdktf.IResolvable): void;
    resetWidgetPie(): void;
    get widgetPieInput(): cdktf.IResolvable | OneDashboardPageWidgetPie[] | undefined;
    private _widgetStackedBar;
    get widgetStackedBar(): OneDashboardPageWidgetStackedBarList;
    putWidgetStackedBar(value: OneDashboardPageWidgetStackedBar[] | cdktf.IResolvable): void;
    resetWidgetStackedBar(): void;
    get widgetStackedBarInput(): cdktf.IResolvable | OneDashboardPageWidgetStackedBar[] | undefined;
    private _widgetTable;
    get widgetTable(): OneDashboardPageWidgetTableList;
    putWidgetTable(value: OneDashboardPageWidgetTable[] | cdktf.IResolvable): void;
    resetWidgetTable(): void;
    get widgetTableInput(): cdktf.IResolvable | OneDashboardPageWidgetTable[] | undefined;
}
export declare class OneDashboardPageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardPage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardPageOutputReference;
}
export interface OneDashboardVariableItem {
    /**
    * A human-friendly display string for this value.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title?: string;
    /**
    * A possible variable value
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#value OneDashboard#value}
    */
    readonly value: string;
}
export declare function oneDashboardVariableItemToTerraform(struct?: OneDashboardVariableItem | cdktf.IResolvable): any;
export declare class OneDashboardVariableItemOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardVariableItem | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardVariableItem | cdktf.IResolvable | undefined);
    private _title?;
    get title(): string;
    set title(value: string);
    resetTitle(): void;
    get titleInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class OneDashboardVariableItemList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardVariableItem[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardVariableItemOutputReference;
}
export interface OneDashboardVariableNrqlQuery {
    /**
    * New Relic account ID(s) to issue the query against.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#account_ids OneDashboard#account_ids}
    */
    readonly accountIds?: number[];
    /**
    * NRQL formatted query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#query OneDashboard#query}
    */
    readonly query: string;
}
export declare function oneDashboardVariableNrqlQueryToTerraform(struct?: OneDashboardVariableNrqlQueryOutputReference | OneDashboardVariableNrqlQuery): any;
export declare class OneDashboardVariableNrqlQueryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OneDashboardVariableNrqlQuery | undefined;
    set internalValue(value: OneDashboardVariableNrqlQuery | undefined);
    private _accountIds?;
    get accountIds(): number[];
    set accountIds(value: number[]);
    resetAccountIds(): void;
    get accountIdsInput(): number[] | undefined;
    private _query?;
    get query(): string;
    set query(value: string);
    get queryInput(): string | undefined;
}
export interface OneDashboardVariable {
    /**
    * Default values for this variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#default_values OneDashboard#default_values}
    */
    readonly defaultValues?: string[];
    /**
    * Indicates whether this variable supports multiple selection or not. Only applies to variables of type NRQL or ENUM.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#is_multi_selection OneDashboard#is_multi_selection}
    */
    readonly isMultiSelection?: boolean | cdktf.IResolvable;
    /**
    * The variable identifier.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#name OneDashboard#name}
    */
    readonly name: string;
    /**
    * Indicates the strategy to apply when replacing a variable in a NRQL query.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#replacement_strategy OneDashboard#replacement_strategy}
    */
    readonly replacementStrategy: string;
    /**
    * Human-friendly display string for this variable.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#title OneDashboard#title}
    */
    readonly title: string;
    /**
    * Specifies the data type of the variable and where its possible values may come from.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#type OneDashboard#type}
    */
    readonly type: string;
    /**
    * item block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#item OneDashboard#item}
    */
    readonly item?: OneDashboardVariableItem[] | cdktf.IResolvable;
    /**
    * nrql_query block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/newrelic/newrelic/3.27.0/docs/resources/one_dashboard#nrql_query OneDashboard#nrql_query}
    */
    readonly nrqlQuery?: OneDashboardVariableNrqlQuery;
}
export declare function oneDashboardVariableToTerraform(struct?: OneDashboardVariable | cdktf.IResolvable): any;
export declare class OneDashboardVariableOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OneDashboardVariable | cdktf.IResolvable | undefined;
    set internalValue(value: OneDashboardVariable | cdktf.IResolvable | undefined);
    private _defaultValues?;
    get defaultValues(): string[];
    set defaultValues(value: string[]);
    resetDefaultValues(): void;
    get defaultValuesInput(): string[] | undefined;
    private _isMultiSelection?;
    get isMultiSelection(): boolean | cdktf.IResolvable;
    set isMultiSelection(value: boolean | cdktf.IResolvable);
    resetIsMultiSelection(): void;
    get isMultiSelectionInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _replacementStrategy?;
    get replacementStrategy(): string;
    set replacementStrategy(value: string);
    get replacementStrategyInput(): string | undefined;
    private _title?;
    get title(): string;
    set title(value: string);
    get titleInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _item;
    get item(): OneDashboardVariableItemList;
    putItem(value: OneDashboardVariableItem[] | cdktf.IResolvable): void;
    resetItem(): void;
    get itemInput(): cdktf.IResolvable | OneDashboardVariableItem[] | undefined;
    private _nrqlQuery;
    get nrqlQuery(): OneDashboardVariableNrqlQueryOutputReference;
    putNrqlQuery(value: OneDashboardVariableNrqlQuery): void;
    resetNrqlQuery(): void;
    get nrqlQueryInput(): OneDashboardVariableNrqlQuery | undefined;
}
export declare class OneDashboardVariableList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OneDashboardVariable[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OneDashboardVariableOutputReference;
}
